# Concerns (questions) with the current implementaion

## There exist alternative `Functor` implementations
See the [relevant subchapter](./s01-alternatives.md)

## ~~It might be better to have a per-lifetime trait for `Functor`s~~ done
See the [relevant subchapter](./s02-lifetimes.md)

## `Stackless` is kind of bad
See the [relevant subchapter](./s03-stackless.md)

## `WeakFunctor<'a>` is not (yet) covariant over the lifetime `'a`
See the [relevant subchapter](./s04-covariance.md)

## `Fail`/`FailMonad`/etc. have unclear semantics
See the [relevant subchapter](./s05-fail.md)

## Is `FutureInstance` actually feasible?
Todo: measure `futures::join` performance.

## Can `WeakFunctor` be an associated type of a `Functor` instead of its supertype?
